Search for customer - Fabric

Search for Customer

cURL

curl --request POST \
  --url https://api.fabric.inc/v3/customers/search \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --data '
{
  "match": {
    "createdAt": {
      "op": "LTE",
      "value": "2023-08-30T23:20:42.822Z"
    },
    "updatedAt": {
      "op": "LTE",
      "value": "2023-08-30T23:20:42.822Z"
    },
    "deletedAt": {
      "op": "LTE",
      "value": "2023-08-30T23:20:42.822Z"
    },
    "additionalAttributes": {
      "op": "IN",
      "key": "gps",
      "value": "beach"
    },
    "isDeleted": false
  },
  "sort": "+firstName,-createdAt",
  "offset": 0,
  "limit": 20
}
'

Python Example

import requests

url = "https://api.fabric.inc/v3/customers/search"

payload = {
    "match": {
        "createdAt": {
            "op": "LTE",
            "value": "2023-08-30T23:20:42.822Z"
        },
        "updatedAt": {
            "op": "LTE",
            "value": "2023-08-30T23:20:42.822Z"
        },
        "deletedAt": {
            "op": "LTE",
            "value": "2023-08-30T23:20:42.822Z"
        },
        "additionalAttributes": {
            "op": "IN",
            "key": "gps",
            "value": "beach"
        },
        "isDeleted": False
    },
    "sort": "+firstName,-createdAt",
    "offset": 0,
    "limit": 20
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)

JavaScript Example (Fetch)

const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: JSON.stringify({
    match: {
      createdAt: {op: 'LTE', value: '2023-08-30T23:20:42.822Z'},
      updatedAt: {op: 'LTE', value: '2023-08-30T23:20:42.822Z'},
      deletedAt: {op: 'LTE', value: '2023-08-30T23:20:42.822Z'},
      additionalAttributes: {op: 'IN', key: 'gps', value: 'beach'},
      isDeleted: false
    },
    sort: '+firstName,-createdAt',
    offset: 0,
    limit: 20
  })
};

fetch('https://api.fabric.inc/v3/customers/search', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));

PHP Example

$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => "https://api.fabric.inc/v3/customers/search",
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "POST",
  CURLOPT_POSTFIELDS => json_encode([
    'match' => [
        'createdAt' => [
                'op' => 'LTE',
                'value' => '2023-08-30T23:20:42.822Z'
        ],
        'updatedAt' => [
                'op' => 'LTE',
                'value' => '2023-08-30T23:20:42.822Z'
        ],
        'deletedAt' => [
                'op' => 'LTE',
                'value' => '2023-08-30T23:20:42.822Z'
        ],
        'additionalAttributes' => [
                'op' => 'IN',
                'key' => 'gps',
                'value' => 'beach'
        ],
        'isDeleted' => false
    ],
    'sort' => '+firstName,-createdAt',
    'offset' => 0,
    'limit' => 20
  ]),
  CURLOPT_HTTPHEADER => [
    "Authorization: Bearer <token>",
    "Content-Type: application/json"
  ],
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}

Response Structure

{
  "query": {
    "offset": 0,
    "limit": 20,
    "count": 100
  },
  "data": [
    {
      "id": "61df41892bf06d00092d0d8a",
      "name": {
        "firstName": "Pat",
        "lastName": "Doe",
        "title": "Dr.",
        "middleName": "E",
        "suffix": "Jr."
      },
      "emailAddress": "test@example.com",
      "isDeleted": false,
      "createdAt": "2023-08-30T23:20:42.822Z",
      "updatedAt": "2023-08-30T23:20:42.822Z",
      "status": "ACTIVE",
      "phone": {
        "number": 15555551234,
        "type": "MOBILE"
      },
      "externalId": "1231012312-312-31231asda",
      "additionalAttributes": {
        "middleName": "user"
      },
      "deletedAt": "2023-08-30T23:20:42.822Z"
    }
  ]
}